/*
 ********************************************************
	Rug Warrior Pro UMH-ISA (SITR)
 ********************************************************
	NOMBRE DEL ARCHIVO:   	musica.c
	FECHA:			
	AUTOR:   Luis M. Jimnez
	DESCRIPCIN:  Canciones sin codificar
				  
	VARIABLES GLOBALES EXTERNAS:
		float a0_note;
		float b0_note;
		float c_note;
		float d_note;
		float e_note;
		float f_note;
		float g_note;
		float a_note;
		float b_note;
		float c2_note;	

		float q_dur;
		float h_dur;
		float dh_dur;

		int note_display=1;

	FUNCIONES EXTERNAS: 
		void note(float freq, float dur);
		void bicycle();
		void note(float freq, float dur);
		void alert_tune();
		void cof();
		void warble(int t_start, int t_stop, int t_del);

	VARIABLES GLOBALES USO INTERNO:
		float tempo_note;	
		float octave_note;

	FUNCIONES USO INTERNO: 

 ********************************************************
*/

/* Well tempered scale:
 a   1.000, a#  1.070,  b  1.143,  c  1.218,  c#  1.295,  d  1.375,  d#   1.457,
 e   1.542, f   1.628,  f  1.718,  g  1.810,  g#  1.904,  A   2.000
*/

/* Fundamental freq of this octave_note.  Ohters: 220, 440, 880, 1760 */
float octave_note = 440.0;	

float a0_note = octave_note * 1.000;
float b0_note = (octave_note * 1.143);
float c_note  = (octave_note * 1.218);
float d_note  = (octave_note * 1.375);
float e_note  = (octave_note * 1.542);
float f_note  = (octave_note * 1.628);
float g_note  = (octave_note * 1.810);
float a_note  = (octave_note * 2.000);
float b_note  = (octave_note * 2.0 * 1.143);
float c2_note = (octave_note * 2.0 * 1.218);

/* Note times: q_dur - quarter, h_dur - half, w_dur - whole */

float tempo_note = 0.25;	/* Duration of a quarter note */
float q_dur = tempo_note;		/* Quarter note */
float h_dur = (2.0 * tempo_note);	/* Half note */
float dh_dur = (3.0 * tempo_note);	/* Dotted half */

int note_display=1;

/* toca una nota y la saca por pantalla */
void note(float freq, float dur)
{ 
	if (note_display)
		printf("Piezo Test      freq%f\n", freq);
	tone(freq,dur);
}

void alert_tune()
{
  tone(1046.5,0.200);
  tone(1396.9,0.200);
  tone(1046.5,0.200);
  tone(698.5,0.200);
}

void bicycle() /* Bicycle built for two */
{
  tone(2093.0,0.769);
  tone(1760.0,0.769);
  tone(1396.9,0.769);
  tone(1046.5,0.769);
  tone(1174.7,0.192);
  tone(1318.5,0.192);
  tone(1396.9,0.192);
  tone(1174.7,0.385);
  tone(1396.9,0.192);
  tone(1046.5,0.962);
  sleep(0.385);
  tone(1568.0,0.769);
  tone(2093.0,0.769);
  tone(1760.0,0.769);
  tone(1396.9,0.769);
  tone(1174.7,0.192);
  tone(1318.5,0.192);
  tone(1396.9,0.192);
  tone(1568.0,0.385);
  tone(1760.0,0.192);
  tone(1568.0,0.962);
  sleep(0.385);
  tone(1760.0,0.192);
  tone(1864.7,0.192);
  tone(1760.0,0.192);
  tone(1568.0,0.192);
  tone(2093.0,0.385);
  tone(1760.0,0.192);
  tone(1568.0,0.192);
  tone(1396.9,0.962);
  tone(1568.0,0.192);
  tone(1760.0,0.385);
  tone(1396.9,0.192);
  tone(1174.7,0.385);
  tone(1396.9,0.192);
  tone(1174.7,0.192);
  tone(1046.5,0.962);
  tone(1046.5,0.192);
  tone(1396.9,0.385);
  tone(1760.0,0.192);
  tone(1568.0,0.385);
  tone(1046.5,0.192);
  tone(1396.9,0.385);
  tone(1760.0,0.192);
  tone(1568.0,0.192);
  tone(1760.0,0.192);
  tone(1864.7,0.192);
  tone(2093.0,0.192);
  tone(1760.0,0.192);
  tone(1396.9,0.192);
  tone(1568.0,0.385);
  tone(1046.5,0.192);
  tone(1396.9,0.962);
}


void cof()
{ 
  note(c_note,q_dur);
  note(f_note,q_dur); note(g_note,q_dur); note(a_note,q_dur);
  note(g_note,dh_dur);
  note(e_note,5.0 * q_dur);
  note(c_note,q_dur);
  note(f_note,q_dur); note(g_note,q_dur); note(a_note,q_dur);
  note(g_note,8.0 * q_dur);
  note(c_note,q_dur);
  note(f_note,q_dur); note(g_note,q_dur); note(a_note,q_dur);
  note(g_note,dh_dur);
  note(e_note,5.0 * q_dur);
  note(g_note,q_dur);
  note(f_note,q_dur); note(e_note,q_dur); note(c_note,q_dur);
  note(c_note,5.0 * q_dur);
  note(c_note,q_dur);
  note(b_note,q_dur); note(a_note,q_dur); note(g_note,q_dur);
  note(b_note,h_dur); note(g_note,q_dur);
  note(a_note,h_dur); note(f_note,q_dur);
  note(g_note,h_dur); note(c_note,q_dur);
  note(b_note,q_dur); note(a_note,q_dur); note(g_note,q_dur);
  note(b_note,8.0 * q_dur);
  note(c_note,q_dur);
  note(b_note,q_dur); note(a_note,q_dur); note(g_note,q_dur);
  note(b_note,h_dur); note(g_note,q_dur);
  note(a_note,h_dur); note(f_note,q_dur);
  note(g_note,h_dur); note(g_note,q_dur);
  note(f_note,q_dur); note(e_note,q_dur); note(c_note,q_dur);
  note(c_note,7.0 * q_dur); 
}

void warble(int t_start, int t_stop, int t_del)
{ 
  int tone_i;
  beeper_on();
  for (tone_i = t_start; (abs(tone_i - t_stop)) > (2 * abs(t_del)); tone_i = tone_i + t_del)
  {
	 set_beeper_pitch( (float) tone_i); 
     msleep((long)1);
  }
  beeper_off();
}
